# mypy-boto3-apigatewayv2

[![PyPI - mypy-boto3-apigatewayv2](https://img.shields.io/pypi/v/mypy-boto3-apigatewayv2.svg?color=blue)](https://pypi.org/project/mypy-boto3-apigatewayv2)
[![PyPI - Python Version](https://img.shields.io/pypi/pyversions/mypy-boto3-apigatewayv2.svg?color=blue)](https://pypi.org/project/mypy-boto3-apigatewayv2)
[![Docs](https://img.shields.io/readthedocs/mypy-boto3-builder.svg?color=blue)](https://mypy-boto3-builder.readthedocs.io/)

Type annotations for
[boto3.ApiGatewayV2 1.14.22](https://boto3.amazonaws.com/v1/documentation/api/1.14.22/reference/services/apigatewayv2.html#ApiGatewayV2) service
compatible with [mypy](https://github.com/python/mypy), [VSCode](https://code.visualstudio.com/),
[PyCharm](https://www.jetbrains.com/pycharm/) and other tools.

Generated by [mypy-boto3-buider 2.2.0](https://github.com/vemel/mypy_boto3_builder).

More information can be found on [boto3-stubs](https://pypi.org/project/boto3-stubs/) page.

## How to install

Make sure you have [mypy](https://github.com/python/mypy) installed and activated in your IDE.

Install `boto3-stubs` for `ApiGatewayV2` service.

```bash
python -m pip install boto3-stubs[apigatewayv2]
```

## How to use

### Client annotations

`ApiGatewayV2Client` provides annotations for `boto3.client("apigatewayv2")`.

```python
import boto3

from mypy_boto3_apigatewayv2 import ApiGatewayV2Client
from mypy_boto3_apigatewayv2.paginator import (
    GetApisPaginator,
    GetAuthorizersPaginator,
    GetDeploymentsPaginator,
    GetDomainNamesPaginator,
    GetIntegrationResponsesPaginator,
    GetIntegrationsPaginator,
    GetModelsPaginator,
    GetRouteResponsesPaginator,
    GetRoutesPaginator,
    GetStagesPaginator,
)
from mypy_boto3_apigatewayv2.type_defs import AccessLogSettingsTypeDef, ...

client: ApiGatewayV2Client = boto3.client("apigatewayv2")

# now client usage is checked by mypy and IDE should provide code auto-complete

# works for session as well
session = boto3.session.Session(region="us-west-1")
session_client: ApiGatewayV2Client = session.client("apigatewayv2")
```

### Paginators annotations

`mypy_boto3_apigatewayv2.paginator` module contains type annotations for all paginators.

```python

client: ApiGatewayV2Client = boto3.client("apigatewayv2")

# Explicit type annotations are optional here
# Type should be correctly discovered by mypy and IDEs
# VSCode requires explicit type annotations
get_apis_paginator: GetApisPaginator = client.get_paginator("get_apis")
get_authorizers_paginator: GetAuthorizersPaginator = client.get_paginator("get_authorizers")
get_deployments_paginator: GetDeploymentsPaginator = client.get_paginator("get_deployments")
get_domain_names_paginator: GetDomainNamesPaginator = client.get_paginator("get_domain_names")
get_integration_responses_paginator: GetIntegrationResponsesPaginator = client.get_paginator("get_integration_responses")
get_integrations_paginator: GetIntegrationsPaginator = client.get_paginator("get_integrations")
get_models_paginator: GetModelsPaginator = client.get_paginator("get_models")
get_route_responses_paginator: GetRouteResponsesPaginator = client.get_paginator("get_route_responses")
get_routes_paginator: GetRoutesPaginator = client.get_paginator("get_routes")
get_stages_paginator: GetStagesPaginator = client.get_paginator("get_stages")
```







### Typed dictionations

`mypy_boto3_apigatewayv2.type_defs` module contains structures and shapes assembled
to typed dictionaries for additional type checking.

```python

def get_structure() -> AccessLogSettingsTypeDef:
    return {
      ...
    }
```


## Dynamic type annotations

`mypy_boto3` command generates `boto3.client/resource` type annotations for
`mypy_boto3_apigatewayv2` and other installed services.

```bash
# Run this command after you add or remove service packages
python -m mypy_boto3
```

Generated type annotations provide overloads for `boto3.client` and `boto3.resource`,
`boto3.Session.client` and `boto3.Session.resource` functions,
so explicit type annotations are not needed.

- `mypy` supports function overloads as expected
- `PyCharm` also supports function overloads, but consumes a lot of RAM, use carefully if you have many services installed
- `VSCode` does not currently support function overloads, use explicit type annotations

```python

# Type is discovered correctly by mypy and PyCharm
# VSCode still needs explicit type annotations
client = boto3.client("apigatewayv2")

session_client = boto3.Session().client("apigatewayv2")
```
